VCMD0028040100000000COMPONENT          
Node "rSimResource"
{
Name "ButtonWithLight"
Id 1
NodeClass 
{
Id 1
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder"

Visible 1
Material  "black"
{
  Ambient
  {
    Red 0.025000000372529
    Green 0.025000000372529
    Blue 0.025000000372529
  }
  Diffuse
  {
    Red 0.100000001490116
    Green 0.100000001490116
    Blue 0.100000001490116
  }
  Specular
  {
    Color
    {
      Red 0.0700000002980232
      Green 0.0700000002980232
      Blue 0.0700000002980232
    }
    Shininess 0.400000005960464
  }
}

Radius 
{
  Expression "Size/2.0"
}

Height 
{
  Expression "Size/2.0"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
SimAttribute "rSimApplyMaterialAttribute"
{
Material  "dark_green"
{
  Ambient
  {
    Red 0
    Green 0.142499998211861
    Blue 0
  }
  Diffuse
  {
    Red 0
    Green 0.569999992847443
    Blue 0
  }
  Specular
  {
    Color
    {
      Red 0
      Green 0.398999989032745
      Blue 0
    }
    Shininess 0.400000005960464
  }
}

}
VCID "c580a303-f848-491f-b11e-ff19cd2f74f5"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Script "from vcScript import *
\n
\napp = getApplication()
\ncomp = getComponent()
\nprop_is_pressed = comp.getProperty('IsPressed')
\ninput_signal = comp.findBehaviour('Input')
\noutput_signal = comp.findBehaviour('Output')
\nmat_on = app.findMaterial('light_green')
\nmat_off = app.findMaterial('dark_green')\n
\ndef OnSignal(signal):
\n  if signal == input_signal:
\n    if signal.Value:
\n      comp.Material = mat_on
\n    else:
\n      comp.Material = mat_off
\n    comp.update()
\n    app.render()
\n
\ndef ButtonPress(beh, action, data):
\n  if action == 1:
\n    output_value = not prop_is_pressed.Value
\n    prop_is_pressed.Value = output_value
\n    output_signal.signal(output_value)
\n    comp.update()
\n    app.render()  
\n
\n
\nbeh = comp.findBehaviour('JogInfo')
\nbeh.OnInteract = ButtonPress"
CompatibilityMode 0
}
Functionality "rSimBoolSignal"
{
Id 2
Name "Input"
Connections
{
"PythonScript"
}
AutomaticReset 1
}
Functionality "rSimBoolSignal"
{
Id 3
Name "Output"
Connections
{
"PythonScript"
}
AutomaticReset 1
}
Functionality "rSimInterface"
{
Id 4
Name "Conn_Input_SignalTester_BooleanSignal"
Flags 16390
Section 
{
Fields
{
rSimSignalField
{
Name "Signal"
Signal "Input"
}
}
}
Abstract 1
}
Functionality "rSimInterface"
{
Id 5
Name "Conn_Output_SignalTester #2_BooleanSignal"
Flags 16390
Section 
{
Fields
{
rSimSignalField
{
Name "Signal"
Signal "Output"
}
}
}
Abstract 1
}
VCID c580a303-f848-491f-b11e-ff19cd2f74f5
OriginalUri vcid:c580a303-f848-491f-b11e-ff19cd2f74f5
Revision 1
Location 1 0 0 0 0 1 0 0 0 0 1 0 -2.25535177328 4.44954174933 0 1 
ActiveSimulationLevel detailed
BOMname  "ButtonWithLight"

BOMdescription  ""

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "Size"
    Value 300
    Group 10
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "IsPressed"
    Value 0
    Group 20
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
}
Node "rSimLink"
{
Name "Link_1"
Id 2
NodeClass 
{
Id 2
Feature "rTransformFeature"
{
Name "Transform"

Visible 1
Transform 
{
  Expression "Tz(Size/2.0)"
}

Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder_1"

Visible 1
Radius 
{
  Expression "Size/2.2"
}

Height 
{
  Expression "Size/8.0"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
}
}
Functionality "rJogInfo"
{
Id 6
Name "JogInfo"
Dof "RZ"
Message "Drag Mouse To Jog Axis"
}
Dof  "TranslationalFollower"
{
  Name "J1"
  Properties
  {
  }
  Driver 0
  AxisType 2
  JointDeflection
  {
    Expression "IsPressed?-Size/16.0:0"
  }
}
Offset 
{
  Expression ""
}
}
}
